LeetCode Exercise In Java - Longest Substring Without Repeating Characters - FAST Solution

Поділитися
Вставка
  • Опубліковано 4 січ 2025

КОМЕНТАРІ • 189

  • @CodingWithJohn
    @CodingWithJohn  2 роки тому +16

    Thanks to Mailgun for sponsoring this video! Head to mailgun.com/john to try Mailgun free today.
    Looking forward to seeing how you guys make this solution even better!

    • @aryansanojraj6618
      @aryansanojraj6618 2 роки тому +1

      Can you let us know the compiler you use for the videos?

    • @ripanpramanick425
      @ripanpramanick425 2 роки тому +1

      Not able to understand how this algo will work for some string like "abcdcga" as we will keep our left pointer at first a and we will increment right pointer, at when right pointer at second c it will get repeated letter and will increment left pointer to b and in next iteration it will move to g and will register length of bcdcg but this substring is already having repeated character. Rather than incrementing left pointer by one we should increment it by lastCharOccuredIndex+1

    • @ZelenoJabko
      @ZelenoJabko 6 місяців тому

      The complexity of your first algorithm is n cubed, not n squared! There is one more loop hidden in String.indexOf, looking for a duplicate character.

  • @playtopgames3261
    @playtopgames3261 2 роки тому +71

    Best java chanel on UA-cam

  • @nahomg6945
    @nahomg6945 2 роки тому +56

    You genuinely have one of the best programming explanation videos on this site, honestly. Funny, I was discussing learning about the Sliding Window algorithm to practice Leetcode questions with a friend yesterday, and lo and behold you've uploaded a great explanation literally 24hrs later, legendary! Could you please upload more Leetcode explanation questions? If not on UA-cam, perhaps a course?

    • @Achraf_0101
      @Achraf_0101 9 місяців тому

      i already signed up in his course but it does not contain any exercises i wonder if there is another course where he solves problems

    • @joydeep_
      @joydeep_ 6 місяців тому

      Same feelings here, we need more leet code problems...

  • @vijal-patel
    @vijal-patel 2 роки тому +26

    please keep doing these, your explanations are so much more in depth than other youtube channels

  • @yashshah2775
    @yashshah2775 28 днів тому

    The way you walked through the solution was like i have never seen anywhere. Most youtubers just jump to the optimal solution. please do more of these! I went to your channel hoping to find a video series of Blind 75. but wasn't there. Please do a playlist of Blind 75. I bet people would love to see those.

  • @jayshreebargohil
    @jayshreebargohil 2 роки тому +13

    I had just solved this problem and found this video. You explained each solution and your approach in the best way. Your way to explaining make things crystal clear John !!

  • @thomas_m3092
    @thomas_m3092 2 роки тому +7

    John, you are a wizard. Everythings looks so logical and simple. Please make more videos like this.

  • @tund_101_hd9
    @tund_101_hd9 2 роки тому +5

    This is probably one of the best tutorials out there and i think UA-cam is with me in this.❤️ I could you not, even though I have watched it already it is every time the first video in my recommended 😂
    Guess I'll watch it twice. Keep up the good work!

  • @shaileshsathe9779
    @shaileshsathe9779 2 роки тому

    Great and in-depth explanation for every approach. I really liked this video. I have found another better approach
    final int n = s.length();
    int len = 0;
    int [] repeat = new int[128];
    for (int c = 0, j = 0, i = 0; j < n; j++) {
    c = s.charAt(j);
    i = Math.max(repeat[c], i);
    len = Math.max(len, j - i +1);
    repeat[c] = j+1;
    }
    return len;
    I somewhat understood, but it would be better if you can explain. Thanks John and keep creating more videos for different problems.

  • @foratzoabi1311
    @foratzoabi1311 11 місяців тому

    Hey John! First of all thanks for the amazing video!
    Short answer for why indexOf is faster in this case:
    It is simply because in this case it has an O(1) runtime, how? here is how:
    Before you slide your right pointer to the right you have already made sure that this substring has different characters, which in the worst case will be 24 characters long. Since you know it will never be longer than 24 characters, or 34 if numbers are included in the string, then it is constant time, because no matter how big your string will be, it will be in the worst case that maximum substring :D so it is related to the valid substring and not to the input! :D
    And since the map indeed has access and write time of O(1) it still has an overhead for hash calculation and storing and etc... which take more operations / time than indexOf in that case, but since none of them is related to n, the one with the shorter/faster operations wins :D
    I hope that was helpful!

  • @minakianrad812
    @minakianrad812 2 роки тому +3

    An excellent in-depth explanation of two approaches to solving this problem. Thank you very much, John.

  • @Michaelpschreib
    @Michaelpschreib 11 місяців тому

    I appreciate that you go into the brute force solution and also the more clever solution. Thanks for these!!

  • @Shivam-gh2mq
    @Shivam-gh2mq 2 роки тому

    I watched till 25:32 and was able to come up with a solution. Thanks for this amazing explanation!

  • @SimanAndGarfunkel
    @SimanAndGarfunkel 10 місяців тому

    I love the final thoughts on the differences of performance between the 2 last algorithms, answered all the questions I had to myself. Thnak you!

  • @whiz-code
    @whiz-code Рік тому

    You are really a coding geek. Even the concepts known, still visit them and keep something. Your explanations are far reaching. Thank you.

  • @elizabeth00653
    @elizabeth00653 Рік тому +1

    John I love your Java explanations, can you please add more leetcode to your channel or bootcamp? I would love to see more Java leetcode solution guides properly explained

  • @claytonalmeida6046
    @claytonalmeida6046 2 роки тому +15

    Would love to watch a complete java dsa course from you

    • @jayshreebargohil
      @jayshreebargohil 2 роки тому

      DSA would be more easy and interesting with John 😀

  • @rushio8673
    @rushio8673 Рік тому +2

    Great job, please keep posting the leetcode solution videos in structural manner(for eg top 50 that includes most practices/datastructures) , this helps a lot in preparing for interviews.

  • @kevolala
    @kevolala Рік тому

    This is the most detailed and accurate explanation of this problem I've seen. 👍

  • @ronakpatel8441
    @ronakpatel8441 2 роки тому +2

    Hey John, I love all of your videos. Learning so many important skills. However, I have one suggestion, If you could make more of this type of problem-solving videos then it would be very helpful to the viewers as it will teach new programmers how to think of a solution to the given problem and how can we actually implement the solution using the programming language.
    By the way thanks again for all efforts that you put in to make this possible.
    Looking forward to seeing more problem-solving videos. Have a wonderful day.

  • @rahulg1715
    @rahulg1715 9 місяців тому

    At 35:00 we should use indexOfFirstAppearenceInsubstring

  • @yasasmaddumage
    @yasasmaddumage 2 роки тому +5

    I love this series. Thank you...

  • @zerkinanastya4410
    @zerkinanastya4410 Рік тому

    Definitely one of the best explanations or just the best, starting from the basic one (brute force) just to kick off and let viewers like me grasp the idea before jumping to more complex solutions. Thank you!

  • @gauravmehta6831
    @gauravmehta6831 5 місяців тому

    A unique way of explanation, clear concise.

  • @zainahmed755
    @zainahmed755 2 роки тому +1

    Best channel ever ! , please keep going with the leatcode series

  • @blairliu9058
    @blairliu9058 2 роки тому +5

    More leetcode videos plzzz! love this series.

  • @thelazymim9338
    @thelazymim9338 2 роки тому

    Best Explanation. Please make videos on All LeetCode's 145 top interview questions. You will be immortal for the Computer Programmers Community.

  • @OsaetinEvbuoma
    @OsaetinEvbuoma 2 роки тому +1

    Hi John. I previously implemented this solution (yours) using a while-loop (and using the map) instead of a for-loop and got similar runtime numbers to the last solution you found (6ms runtime). Not sure why that's the case. But yeah, the last solution, intuitively should be a worse runtime even though it seems like it performs better. It's also a clever solution too. Nice work!

  • @liamoua9192
    @liamoua9192 2 роки тому

    John, you’ve helped me understand DS&A in Java better than before. The way you explained things are easy to understand and follow. I’m a visual learner and your explanations makes it easier for me visualize & understand. Thank you and please keep these leet code videos coming. Your other videos on Java has truly helped me understand Java so much more than my professors lol you are incredible in the work that you’re doing for me and many. We cannot thank you enough ❤ I appreciate you.

    • @CodingWithJohn
      @CodingWithJohn  2 роки тому

      Thanks so much for the very kind words!

    • @91-ritikjain36
      @91-ritikjain36 Рік тому

      when we get full playlist of leetcode in java you are amazing i am from india @@CodingWithJohn

  • @EdgarRamirez-ry2je
    @EdgarRamirez-ry2je 2 роки тому +1

    Excelent explication of a leetcode coding challenge, thanks i hope to see more videos of coding challenges medium and hard

  • @markmuyot2436
    @markmuyot2436 10 місяців тому

    I liked your videos, you made them all easy to grasp! please do more leetcodes tutorials and data structures and algorithms content

  • @lanatimmo3686
    @lanatimmo3686 2 роки тому +4

    It's great! Please, do more Leetcode Exercise explanations!🙏

  • @EdgarRamirez-ry2je
    @EdgarRamirez-ry2je Рік тому

    More videos like this with solutions for diferent letcode, hackerank problems this is very much usefull to improve skills, you explain as a master

  • @MTB_Bay_Area
    @MTB_Bay_Area 2 роки тому +2

    For the brute force solution. I suggest checking if the max need to be updated in the "if contains part" that makes sure that we only do it right before we break. It is one time per substring. We fount a substring, now, let's check if it is better than the other we had so far. Second, I will suggest using HashSet instead of StringBuilder. HashSet has contains method and it is faster.

  • @sankalp.m.patilsmp1472
    @sankalp.m.patilsmp1472 2 роки тому +1

    this channel has wonderful content, and easy to understand explaination.

  • @zoflax
    @zoflax 2 роки тому +1

    this series is actually so good.

  • @gurjeevjohal5459
    @gurjeevjohal5459 2 роки тому +1

    You're videos are so helpful, one 5 minute video is worth 6 hours reading a chapter in a book. Please can you do some videos or a playlist on design patterns. Thanks!

  • @SimoLPers
    @SimoLPers Рік тому +1

    I'm currently just at the brute-force method in the video, but for the lookups I'd probably use a hashset.
    I would therefore prevent an O(n²) lookup.
    But the brute-force method was the first idea for me as well.

  • @pedroalves5482
    @pedroalves5482 2 роки тому

    Hi, first time watching your videos, and I love the clarity of your explanation.
    I think I figured out the reason of Map been more slowest than last example, when you use the hash map you as writing and updating the data, to have the current letter position. On the other side the s.index only search if exist this value.

  • @ashashankar29
    @ashashankar29 Рік тому

    Excellent explanation and solution. I clearly understood the problem and solution. thank you

  • @jordanT_alker
    @jordanT_alker 8 місяців тому

    Interesting!
    I am very honest with myself, I am not seeing the full picture when it occurs to recursion;
    However, I did grasp the idea of the "quicksort" method a bit better, not 100% but we are learning.
    I can see this is almost similar to an array.

  • @rcciit9226
    @rcciit9226 Рік тому

    Wow so easy to learn and understand , you have a new student sir.

  • @deepakroy3476
    @deepakroy3476 10 місяців тому

    You make programming easy and simple

  • @markmuyot2436
    @markmuyot2436 Рік тому

    Hi John I like how you present your leetcode solutions, so easy to follow and understand. Hope to see more of this or if you have anothe platform teaching leetcode problems , I would be happy to know.. Thank you

  • @Soromeister
    @Soromeister 2 роки тому +1

    Love the series and quite a nice explanation on the different approaches, although the last one is confusing for me.

  • @bendror8302
    @bendror8302 Рік тому

    Nice to learn from you John, can you add more solutions from LeetCode?

  • @user-kuzya2023
    @user-kuzya2023 2 роки тому

    Спасибо Джон. Продолжайте и дальше радовать нас своими видео. Thanks John. Continue to delight us with your videos

  • @hendhasnaoui9419
    @hendhasnaoui9419 Рік тому

    i'm really impressed 👍👍. keep on going 👏👏👏

  • @SaifaldeenSAH
    @SaifaldeenSAH 2 роки тому

    The best explaining ever, hoping to make more videos plz or DS and Algo videos. Thank you.

  • @otisopoku37
    @otisopoku37 Рік тому

    Your explanations are very good. More leetcode!!!!!!!!!

  • @ArunKumar-jk5pq
    @ArunKumar-jk5pq 2 роки тому

    This is awesome way of teaching! Thanks John!

  • @tiagocarvalho4119
    @tiagocarvalho4119 Рік тому +7

    You have to be careful when using a MAP to lookup something because, even though its O(1) in time complexity, there is a lot of overhead. Let's say that the constant time for a lookup in a MAP is always 500 nanoseconds, if the indexOf (that has a time complexity of O(n)) takes only 300 nanoseconds because it finds the answer in the first few characters, then the indexOf will perform better. This obviously can be measured and we can come up with some threshold that tells us what algorithm to use in each situation. My guess is that in the English language indexOf will always perform better because we are dealing with words that are small in size (there is always the repeating space character).

  • @logesh9141
    @logesh9141 2 роки тому +1

    hi John,
    The way of explanation which you are giving is excellent.
    Since, I am mostly working JAVA. You videos are very mich helpful for me to achieve greater heights in my life.
    I mostly use ECLIPSE for my Java Projects. If possible please guide me in using Intellij with each and every shortcuts.
    Thanks in Advance,
    Logesh

  • @Verdarin
    @Verdarin Рік тому +1

    I know this is a bit late, but I believe Map is quite slow in runtime from what I heard and so it doesnt give off the best speed, Map is a great to use if you dont care much about speed as much as you want cleaner and simple code (tho run time is and should be priority)

  • @Laughing_india_
    @Laughing_india_ 2 роки тому

    love from india❤️ Pls upload a problem on daily basis

  • @swagatpandak7325
    @swagatpandak7325 2 роки тому +1

    Continue this series in java please.Thanks john.

    • @CostaKazistov
      @CostaKazistov 2 роки тому

      Yes, please!
      Most LeetCode videos out there are either Python or C++
      Definitely want to see more LeetCode walkthroughs in Java (or Kotlin)

  • @sheko4515
    @sheko4515 10 місяців тому

    Can you please do more videos like this as you explain it in a great way.

  • @laharibasu9731
    @laharibasu9731 2 роки тому

    Can you please make more of these leetcode java solutions videos. They are of great help and you make us understand wonderfully.

  • @olyamychko4315
    @olyamychko4315 2 роки тому +1

    Thanks for great explanations!

  • @Tibetan-experience
    @Tibetan-experience 2 роки тому

    Thanks John. Always putting these awesome videos.

  • @adriangonzalez6564
    @adriangonzalez6564 2 роки тому

    Awesome video!!!
    You are by far the best coding tecaher i could find in internet.
    Coud you do a video explaining how to read a csv file in Java?? It would be great.
    Really very good content, keep doing it

  • @antonignatenko7776
    @antonignatenko7776 2 роки тому

    if possible more videos like this, especially interested in thought process behind solutioon

  • @quandingleberry445
    @quandingleberry445 2 роки тому

    Great video, also I think the last part might be bc of best case scenario

  • @Asingh42
    @Asingh42 3 місяці тому

    I tried a better idea to use a fixed size array for character mapping it got more optimised thanks for the video need more leetcode content

  • @aneeshdixit4
    @aneeshdixit4 2 роки тому

    Thank you for the amazing and clear explaination.
    Can you explain this next? 992. Subarrays with K Different Integers.

  • @jonathanhawkins9147
    @jonathanhawkins9147 2 роки тому

    Yum just a subscriber with the initial sponsor ad

  • @saeednoshadi3922
    @saeednoshadi3922 2 роки тому +1

    This playlist is amazing, Why don't you continue this series of videos?

  • @benjaminandersonii9842
    @benjaminandersonii9842 Рік тому +3

    The reason for the final solution being faster is because while hash tables have "constant" lookup time it still takes time. Depending on the hashing function and the initial size of the hashmap the lookup, add, and resize functions may be more time consuming than just linearly looking through an array of characters. Especially if the hashing function has division, because of how bad computers are at it. So rather than your hashmap having O(1) time complexity for lookup its probably more like O(100) which is potentially smaller than the size of n.
    Sorry for the long rambling answer, but yeah hashmaps are great, if you know how the data is being put into them. They also take up a *bunch* of space, so finding an algorithm that is similar in functionality, but doesn't use them is always the way to go.

    • @vedantjha2327
      @vedantjha2327 Рік тому

      True, just to add your answer, hashmap has constant time complexity in average case, but O(n) in worst case. So it's not 100% perfect n effective in all cases

  • @dadaboymasharipov2653
    @dadaboymasharipov2653 2 роки тому +1

    Hi there!! I really like your videos so much you make them easy to understand!! I want to ask you something can you recommend a book or books to improve our problem solving skill and to learn data structures

  • @automationselenium1331
    @automationselenium1331 2 місяці тому

    Thank you, John.

  • @VinuCP
    @VinuCP Рік тому

    Thanks John for awesome video and great explanation. For the Map solution wouldn't it also help to add an exit condition to break the loop
    if (maxLength > input.length() - right + 1) - so we need not iterate the remaining characters in the input.

  • @158thavashankarrajakc9
    @158thavashankarrajakc9 2 роки тому

    need more tutorials please :) thank you!

  • @NiChOlAs-gw7iw
    @NiChOlAs-gw7iw 2 роки тому

    wow pls, do more Leetcode exercise explanations!

  • @chrisjames278
    @chrisjames278 2 роки тому

    great video. Keep them coming!

  • @nicovogel9924
    @nicovogel9924 2 роки тому +2

    I would never thought of HashMap is it possible to do the same thing with a list just if list.contains(a) list.remove(a) list.append(a). Could you pls make a video about how fast all these datastructures in comparison are.
    you can explain very good :)

  • @psg9278
    @psg9278 2 роки тому +1

    Thanks Please do more

  • @shakilansari8967
    @shakilansari8967 2 роки тому

    Lots of love from India...

  • @sysybaba420
    @sysybaba420 Рік тому

    @31:42 -> is there a better way to find length of the substring(right - left + 1)? Can we do something like s.subString(left, right) and pass this as an argument to s.length() somehow and return the length of that substring? thoughts?

    • @sysybaba420
      @sysybaba420 Рік тому

      Also at 30:00 why not just do a left++?

  • @bhaveshgavali531
    @bhaveshgavali531 2 роки тому +1

    29:53 What if we just did Left++ , I think still works the same, correct me if I am wrong.

  • @Harsha._.
    @Harsha._. 2 роки тому

    Awesome best explanation 👏

  • @ozzDeveveloperOpenForWork
    @ozzDeveveloperOpenForWork 2 роки тому

    perfect. you have more question answer videos, like a playlist of them? Thanks

  • @MTB_Bay_Area
    @MTB_Bay_Area 2 роки тому +1

    Maybe HashMap takes longer because I the calculation of the hash? To get to a value HashMap first calculate hash value, and only then go to the location.

  • @yedum321
    @yedum321 2 роки тому

    I've been binging your videos. I feel like God sent you to me. Thank you

  • @puneetarora1714
    @puneetarora1714 2 роки тому +1

    buddy make an in depth video for regex expressions please

    • @toby9999
      @toby9999 4 місяці тому

      Yeah, good idea. Regex really messes with the brain.

  • @rameezalam1968
    @rameezalam1968 Рік тому

    Hi Johnny sin, good to see in as a software developer role as well

  • @xeanluxcrille6847
    @xeanluxcrille6847 2 роки тому +3

    I'm not entirely sure, but the answer to the difference in time complexity might be in how indexOf is implemented in the first place. I'm not an expert at all, but what if the indexOf method itself already utilizes the exact same Map implementation? Meaning, your Map implementation could be a duplicate of indexOf(), except indexOf() doesn't have the extra steps within the implementations of contains() and get() because it's already encapsulated in core Java. I'm just guessing here, of course. Pretty sure I could be wrong.

  • @bendror8302
    @bendror8302 Рік тому +1

    wow thanks 🙏

  • @jatinkumar7287
    @jatinkumar7287 2 роки тому

    Thanks for this explaination🥰

  • @bartoszjozwicki4541
    @bartoszjozwicki4541 2 роки тому +1

    Hello John, another great video. That is my solution (better than brute force, worse than fast solution but probably quite easy to understand), thanks for your work!
    class Solution {
    public int lengthOfLongestSubstring(String s) {
    Integer currentRun = 0;
    Integer longestSoFar = 0;
    char[] arr = s.toCharArray();
    HashMap hM = new HashMap();
    for(int i = 0; i < arr.length; i++)
    {
    if(hM.containsKey(arr[i]))
    {
    currentRun = hM.size();
    if(longestSoFar < currentRun)
    {
    longestSoFar = currentRun;
    }
    i = hM.get(arr[i]);
    hM.clear();
    }
    else
    {
    hM.put(arr[i], i);
    }
    }

    currentRun = hM.size();
    if(longestSoFar < currentRun)
    {
    longestSoFar = currentRun;
    }
    return (int)longestSoFar;
    }
    }

  • @germimonte
    @germimonte 2 роки тому +1

    as for the better time, my best guess is a combination of the sample data and the relatively massive overhead of the default HashMap implementation, using arrays to implement your own map SHOULD in theory produce better results, I'll test it later. Or you could just pass 127 as the initial capacity of the map?

  • @_Anna_Nass_
    @_Anna_Nass_ Рік тому

    More leetcode problems!!! I like this style of video 🧌

  • @bekuostudio
    @bekuostudio Рік тому

    Thanks for the clear explanation. I'm struggling with tech interviews. How am I supposed to complete a challenge in a short time? I just got stuck in the last one. I'm trying so hard to understand. I've been practicing LeetCode exercises, but there's always something tricky, and I've never seen anything similar before. It's so frustrating

  • @arthurmagamedov3179
    @arthurmagamedov3179 Рік тому

    Thanks John for the amazing video!! As for maps - what is the low level implementation of maps in JVM code? I mean, does it calculate the hash for the key when put or get methods are invoked? If it does, then adding or reading keys will be quite expensive , and explains why indexOf works faster.

  • @germimonte
    @germimonte 2 роки тому +8

    given that there's a finite and constant number of letters, you could probably replace the HashMap with a regular array for a negligible decrease in time and memory

    • @CodingWithJohn
      @CodingWithJohn  2 роки тому +6

      Yeah it could be the case that despite the technical time complexity being lower, because n will never be more than 50,000, simple sequential array searches might just be more performant

    • @cipherxen2
      @cipherxen2 2 роки тому +4

      @@CodingWithJohn you don't need array of 50000 elements, just 255 for ASCII characters

    • @bhaskarpurkayastha485
      @bhaskarpurkayastha485 2 роки тому +1

      @@cipherxen2 and a character can be found in this array in O(1) time by -
      int lastEncountered = charIndexes[currentChar]; Initialize charIndexes[255] with all -1;

  • @matteodidone9801
    @matteodidone9801 2 роки тому

    Is it just me, or "Coding With John" is the new "Alex Lee" when it comes to learning Java?

  • @kalan91
    @kalan91 2 місяці тому

    In order to speed up the java solution and still do this in O(n) time and O(1) space - instead of using HashMap, we can use an int array of 128 characters new int[128]; (since ascii consists of 128 characters, that can be converted automatically to int). then we avoid HashMap object creation and it runs faster (plus we don't need to calculate hash values for each map.get() and add() - I know it happens in constant time, but it takes more time to compute than just using an index of an array. The solution at the end unfortunatelly is not efficient, it's O(n^2) - it runs fast only in testcases covered by leetcode.

  • @odaia.7519
    @odaia.7519 2 роки тому +1

    I think maps are very performant in java, so it's not because of the map functions. What i think it's because of initialize an object of it and this takes time. I saw this while measuring a function using map in my performance project.

  • @manambalaji9547
    @manambalaji9547 Рік тому

    Really you are awesome 🎉

  • @chinmayrath8494
    @chinmayrath8494 2 роки тому

    thanks for the video !!

  • @benignexistence4558
    @benignexistence4558 3 місяці тому

    it's crazy to see that last solution. i am watching this after submitting my solution, which is almost identical. however, i didn't know you can set the start index of String.indexOf(), so I had a String t that was set to s.substring(left, right) every loop and String c that was set to s.charAt(right). I then had the left pointer move by using ```left = (t.contains(c)) ? left + t.indexOf(c) + 1 : left;``` lmao. Funny enough, it gave the exact same time of 5ms, but their version uses a bit less space (mine used 44.94MB)